Gyoto::Worldline Class Referenceabstract

Timelike or null geodesics. More...

`#include <GyotoWorldline.h>`

Inheritance diagram for Gyoto::Worldline:

## Classes

class | IntegState

## Public Member Functions

| Worldline ()
| Default constructor.
| Worldline (const Worldline &)
| Copy constructor.
| Worldline (Worldline *orig, size_t i0, int dir, double step_max)
| Refine constructor.
virtual | ~Worldline ()
| Destructor.
size_t | getImin () const
| Get imin_.
size_t | getImax () const
| Get imax_.
size_t | getI0 () const
| Get i0_.
virtual double | getMass () const =0
| Get mass of particule.
void | metric (SmartPointer< Metric::Generic >)
| Set metric Smartpointer.
SmartPointer< Metric::Generic > | metric () const
| Get metric.
void | initCoord (std::vector< double > const &)
std::vector< double > | initCoord () const
virtual void | setInitCoord (const double coord[8], int dir, double const Ephi[4], double const Etheta[4])
| Set Initial coordinate.
virtual void | setInitCoord (const double coord[8], int dir=0)
| Set Initial coordinate.
virtual void | setInitCoord (double const pos[4], double const vel[3], int dir=0)
| Set initial coordinate.
virtual void | setPosition (double const pos[4])
| Set initial 4-position.
virtual void | setVelocity (double const vel[3])
| Set initial 3-velocity.
void | reset ()
| Forget integration, keeping initial contition.
void | reInit ()
| Reset and recompute particle properties.
virtual std::string | className () const
| "Worldline"
virtual std::string | className_l () const
| "worldline"
void | integrator (std::string const &type)
| Set the integrator.
std::string | integrator () const
| Describe the integrator used by state_.
void | integ31 (bool integ)
| Set the integrator kind to 3+1 or 4D.
bool | integ31 () const
| Get the kind of geodesic equation integrated by state_.
double | deltaMin () const
| Get delta_min_.
void | deltaMin (double h1)
| Set delta_min_.
double | deltaMax () const
| Get delta_max_.
void | absTol (double)
| Set abstol_.
double | absTol () const
| Get abstol_.
void | relTol (double)
| Set reltol_.
double | relTol () const
| Get reltol_.
void | maxCrossEqplane (double)
| Set #maxCrosEqplane_.
double | maxCrossEqplane () const
| Get maxCrossEqplane_.
virtual double | deltaMax (double const pos[8], double delta_max_external) const
void | deltaMax (double h1)
double | deltaMaxOverR () const
| Get delta_max_over_r_.
void | deltaMaxOverR (double t)
| Set delta_max_over_r_.
void | delta (const double delta)
| Expand memory slots for polarization vectors.
void | delta (double, const std::string &unit)
| Set delta_ in specified units.
double | delta () const
| Get delta_.
double | delta (const std::string &unit) const
| Get delta_ in specified units.
double | tMin () const
| Get tmin_.
double | tMin (const std::string &unit) const
| Get tmin_ in specified unit.
void | tMin (double tlim)
| Set tmin_.
void | tMin (double, const std::string &unit)
| Set tmin_ in specified unit.
void | adaptive (bool mode)
| Set adaptive_.
bool | adaptive () const
| Get adaptive_.
void | secondary (bool sec)
| Set secondary_.
bool | secondary () const
| Get secondary_.
void | parallelTransport (bool pt)
| Set parallel_transport_.
bool | parallelTransport () const
| Get parallel_transport_.
void | maxiter (size_t miter)
| Set maxiter_.
size_t | maxiter () const
| Get maxiter_.
double const * | getCst () const
| Returns the worldline's cst of motion (if any).
void | setCst (double const *cst, size_t const ncsts)
| Set Metric-specific constants of motion.
void | constantsOfMotion (std::vector< double > const cstv)
| Set Metric-specific constants of motion.
std::vector< double > | constantsOfMotion () const
| Return a copy of the Metric-specific constants of motion.
void | setInitialCondition (SmartPointer< Metric::Generic > gg, const double coord[8], const int dir, double const Ephi[4], double const Etheta[4])
| Set or re-set the initial condition prior to integration.
void | setInitialCondition (SmartPointer< Metric::Generic > gg, const double coord[8], const int dir)
| Set or re-set the initial condition prior to integration.
void | getInitialCoord (std::vector< double > &dest) const
| Get initial coordinates + base vectors.
void | getCoord (size_t index, Gyoto::state_t &dest) const
| Get coordinates+base vectors corresponding to index.
void | getCoord (size_t index, Gyoto::state_t &dest)
| Get coordinates+base vectors corresponding to index.
void | getCoord (double date, Gyoto::state_t &dest, bool proper=false)
| Get coordinates+base vectors corresponding to date dest[0].
void | getCartesianPos (size_t index, double dest[4]) const
| Get Cartesian expression of 4-position at index.
virtual void | xStore (size_t ind, state_t const &coord, double tau)
| Store coord at index ind.
virtual void | xStore (size_t ind, state_t const &coord)=delete
| Obsolete, update your code.
virtual void | xStore (size_t ind, double const coord[8])=delete
| Obsolete, update your code.
virtual void | xFill (double tlim, bool proper=false)
| Fill x0, x1... by integrating the Worldline from previously set inittial condition to time tlim.
size_t | get_nelements () const
| Get number of computed dates.
void | get_t (double *dest) const
| Get computed dates.
void | get_tau (double *dest) const
| Get computed proper times or values of the affine parameter.
void | getCartesian (double const *const dates, size_t const n_dates, double *const x, double *const y, double *const z, double *const xprime=NULL, double *const yprime=NULL, double *const zprime=NULL)
| Get the 6 Cartesian coordinates for specific dates.
void | get_xyz (double *x, double *y, double *z) const
| Get 3-position in cartesian coordinates for computed dates.

void

getCoord (double const *const dates, size_t const n_dates, double *const x1dest, double *const x2dest, double *const x3dest, double *const x0dot=NULL, double *const x1dot=NULL, double *const x2dot=NULL, double *const x3dot=NULL, double *ep0=NULL, double *ep1=NULL, double *ep2=NULL, double *ep3=NULL, double *et0=NULL, double *et1=NULL, double *et2=NULL, double *et3=NULL, double *otime=NULL, bool proper=false)

| Get 8-coordinates for specific dates.
void | getCoord (double *x0, double *x1, double *x2, double *x3) const
| Get all computed positions.
void | checkPhiTheta (double coord[8]) const
| Bring θ in [0,Π] and φ in [0,2Π].
void | getSkyPos (SmartPointer< Screen > screen, double *dalpha, double *ddellta, double *dD) const
| Get computed positions in sky coordinates.
void | get_dot (double *x0dot, double *x1dot, double *x2dot, double *x3dot) const
| Get computed 4-velocities.
void | get_prime (double *x1prime, double *x2prime, double *x3prime) const
| Get computed 3-velocities.
void | save_txyz (char *fichierxyz) const
| Save in a file.
void | save_txyz (char *const filename, double const t1, double const mass_sun, double const distance_kpc, std::string const unit, SmartPointer< Screen > sc=NULL)
| Save, converted.

## Public Attributes

int | stopcond
| Whether and why integration is finished.

## Protected Member Functions

virtual void | xAllocate ()
| Allocate x0, x1 etc. with default size.
virtual void | xAllocate (size_t size)
| Allocate x0, x1 etc. with a specified size.
virtual size_t | xExpand (int dir)
| Expand x0, x1 etc... to hold more elements.
virtual void | xExpand (double *&x, int dir)
| Expand one array to hold more elements.
virtual void | eAllocate ()
| Allocate ep0_ ... et3_.
virtual void | eDeallocate ()
| Deallocate ep0_ ... et3_.
virtual void | eExpand (int dir)
virtual void | tell (Gyoto::Hook::Teller *)
| This is how a Teller tells.

## Protected Attributes

SmartPointer< Gyoto::Metric::Generic > | metric_
| The Gyoto::Metric in this part of the universe.
double * | tau_
| proper time or affine parameter
double * | x0_
| t or T
double * | x1_
| r or x
double * | x2_
| θ or y
double * | x3_
| φ or z
double * | x0dot_
| tdot or Tdot
double * | x1dot_
| rdot or xdot
double * | x2dot_
| θdot or ydot
double * | x3dot_
| φdot or zdot
double * | ep0_
double * | ep1_
| Coordinate of first base vector to parallel transport.
double * | ep2_
| Coordinate of first base vector to parallel transport.
double * | ep3_
| Coordinate of first base vector to parallel transport.
double * | et0_
| Coordinate of first base vector to parallel transport.
double * | et1_
| Coordinate of Second base vector to parallel transport.
double * | et2_
| Coordinate of Second base vector to parallel transport.
double * | et3_
| Coordinate of Second base vector to parallel transport.
size_t | x_size_
| Coordinate of Second base vector to parallel transport.
size_t | imin_
| Minimum index for which x0_, x1_... have been computed.
size_t | i0_
| Index of initial condition in array.
size_t | imax_
| Maximum index for which x0_, x1_... have been computed.
bool | adaptive_
| Whether integration should use adaptive delta.
bool | secondary_
| Experimental: choose 0 to compute only primary image.
bool | parallel_transport_
| Whether to parallel transport a local triad.
double | delta_
| Initial integrating step.
double | tmin_
| Time limit for the integration (geometrical units).
double * | cst_
| Worldline's csts of motion (if any).
size_t | cst_n_
| Number of constants of motion.
int | wait_pos_
| Hack in setParameters().
double * | init_vel_
| Hack in setParameters().
size_t | maxiter_
| Maximum number of iterations when integrating.
double | delta_min_
| Minimum integration step for the adaptive integrator.
double | delta_max_
| Maximum integration step for the adaptive integrator.
double | delta_max_over_r_
| Numerical tuning parameter.
double | abstol_
| Absolute tolerance of the integrator.
double | reltol_
| Absolute tolerance of the integrator.
double | maxCrossEqplane_
| Maximum number of crossings of equatorial plane.
SmartPointer< Worldline::IntegState::Generic > | state_
| An object to hold the integration state.

## Detailed Description

Timelike or null geodesics.

Their are two derived classes: Photon and Star. A Worldline can be integrated from an initial condition either backward or forward in time using xFill() (Photon::hit() also integrates the Worldline). Member state_ holds the integration state as well as an integrator. There are several kinds of integration states, that derive from IntegState::Generic.

The coordinates of the Worldline are stored in x0_, x1_, x2_, x3_, x0dot_, x1dot_, x2dot_ ans x3dot_. Those arrays are extended as needed using xExpand(). These coordinates can be retrieved using get_t(), get_xyz(), getCartesian(), getCoord() etc.

Worldline does not derive from Object, and does not instantiate a Property list. This is because this would lead to multiple inheritance of the Object base in derived classes. Instead, #GyotoWorldline.h provides a few macros that can be used to include the Worldline properties in a derived classe's Property list:

- GYOTO_WORLDLINE is to be used in a public section of the derived class declaration (.h file); it declares wrappers around the Worldline property accessors;
- GYOTO_WORLDLINE_ACCESSORS is to be used with the class definition (.C file; it defines the accessors declared by GYOTO_WORLDLINE;
- GYOTO_WORLDLINE_PROPERTIES declares the Properties that use these accessors. It must be used like e.g. GYOTO_PROPERTY_DOUBLE, between GYOTO_PROPERTY_START andf GYOTO_PROPERTY_END.
- Finally, GYOTO_WORLDLINE_PROPERTY_END is a drop-in replacement for GYOTO_PROPERTY_END that calls GYOTO_WORLDLINE_PROPERTIES and GYOTO_WORLDLINE_ACCESSORS.

## Constructor & Destructor Documentation

## Worldline()

Gyoto::Worldline::Worldline | ( | Worldline * | orig,
|  | size_t | i0,
|  | int | dir,
|  | double | step_max )

Refine constructor.

Meant to instantiate a copy of orig with a smaller step to refine integration, for instance for more accurate radiative transfer integration.

See Photon::Photon(Photon* orig, size_t i0, int dir, double step_max) and Photon::Refined.

Parameters

  orig | Worldline to refine
  i0 | Index of coordinate in orig to take as initial condition
  dir | Direction of integration
  step_max | Maximum integration step

## Member Function Documentation

## checkPhiTheta()

void Gyoto::Worldline::checkPhiTheta | ( | double | coord[8] | ) | const

Bring θ in [0,Π] and φ in [0,2Π].

checkPhiTheta() Modifies coord if the corrdinates are spherical-like so that coord[2]=theta is in [0,pi] and coord[3]=phi is in [0,2pi]. Important to use in all astrobj in spherical coordinates to prevent "z-axis problems".

## className()

virtual std::string Gyoto::Worldline::className | ( |  | ) | const

virtual

"Worldline"

Reimplemented in Gyoto::Astrobj::Blob, Gyoto::Astrobj::InflateStar, Gyoto::Astrobj::Star, Gyoto::Astrobj::StarTrace, and Gyoto::Photon.

## className_l()

virtual std::string Gyoto::Worldline::className_l | ( |  | ) | const

virtual

"worldline"

Reimplemented in Gyoto::Astrobj::Blob, Gyoto::Astrobj::InflateStar, Gyoto::Astrobj::Star, Gyoto::Astrobj::StarTrace, and Gyoto::Photon.

## constantsOfMotion() [1/2]

std::vector< double > Gyoto::Worldline::constantsOfMotion | ( |  | ) | const

Return a copy of the Metric-specific constants of motion.

This function return a copy of the constants of motion. getCst() can be used to retrieve a pointer to the actual array used internally which is slightly more efficient for read-only access.

## constantsOfMotion() [2/2]

void Gyoto::Worldline::constantsOfMotion | ( | std::vector< double > const | cstv | ) |

Set Metric-specific constants of motion.

The will (re)allocate Worldline::cst_, copy cst into it, and set Worldline::cst_n_.

This is the same as getCst using a vector instead of a C-style array.

## delta()

void Gyoto::Worldline::delta | ( | const double | delta | ) |

Expand memory slots for polarization vectors.

Assignment to another Worldline Set delta_

## deltaMax() [1/2]

virtual double Gyoto::Worldline::deltaMax | ( | double const | pos[8],
|  | double | delta_max_external ) const

virtual

Get delta max at a given position

Parameters

  [in] | pos | 4-position
  [in] | delta_max_external | external constraint on delta_max

Returns
  the smallest value between delta_max_, delta_max_external, and R*delta_max_over_r_ where R is pos[1] in spherical coordinates and max(x1, x2, x3) in Cartesian coordinates.

Reimplemented in Gyoto::Astrobj::EquatorialHotSpot, and Gyoto::Astrobj::Star.

## deltaMax() [2/2]

void Gyoto::Worldline::deltaMax | ( | double | h1 | ) |

Set delta_max_

## eAllocate()

virtual void Gyoto::Worldline::eAllocate | ( |  | ) |

protected virtual

Allocate ep0_ ... et3_.

Allocate memory for polarization vectors

## eDeallocate()

virtual void Gyoto::Worldline::eDeallocate | ( |  | ) |

protected virtual

Deallocate ep0_ ... et3_.

Deallocate memory for polarization vectors

## eExpand()

virtual void Gyoto::Worldline::eExpand | ( | int | dir | ) |

protected virtual

Call xExpand(double * &x, int dir) on ep0_, ep1_ etc.

## getCartesian()

void Gyoto::Worldline::getCartesian | ( | double const *const | dates,
|  | size_t const | n_dates,
|  | double *const | x,
|  | double *const | y,
|  | double *const | z,
|  | double *const | xprime = NULL,
|  | double *const | yprime = NULL,
|  | double *const | zprime = NULL )

Get the 6 Cartesian coordinates for specific dates.

The 6 coordinates (x, y, z, dx/dt, dy/dt, dz/dt) will be computed using the integrator and interpolated if necessary, so they will be as accurate as possible. Transforming to Cartesian coordinates is not necessarily meaningful.

Parameters

  [in] | dates | List of dates for which the coordinates are to be computed;
  [in] | n_dates | Number of dates to compute ;
  [out] | x,y,z,xprime,yprime,zprime | Arrays in which to store the result. These pointer may be set to NULL to retrieve only part of the information. Else, they must be pre-allocated.

## getCoord() [1/5]

void Gyoto::Worldline::getCoord | ( | double * | x0,
|  | double * | x1,
|  | double * | x2,
|  | double * | x3 ) const

Get all computed positions.

Get all the pre-computed 8 coordinates (e.g. thanks to a prior call to xFill()) of this worldline.

## getCoord() [2/5]

void Gyoto::Worldline::getCoord | ( | double const *const | dates,
|  | size_t const | n_dates,
|  | double *const | x1dest,
|  | double *const | x2dest,
|  | double *const | x3dest,
|  | double *const | x0dot = NULL,
|  | double *const | x1dot = NULL,
|  | double *const | x2dot = NULL,
|  | double *const | x3dot = NULL,
|  | double * | ep0 = NULL,
|  | double * | ep1 = NULL,
|  | double * | ep2 = NULL,
|  | double * | ep3 = NULL,
|  | double * | et0 = NULL,
|  | double * | et1 = NULL,
|  | double * | et2 = NULL,
|  | double * | et3 = NULL,
|  | double * | otime = NULL,
|  | bool | proper = false )

Get 8-coordinates for specific dates.

The coordinates will be computed using the integrator, so they will be as accurate as possible. Some heuristics are used to speed up the process and it is presumably faster to call this routine with a sorted list of dates. The line will be integrated further as required. An error will be thrown if it is not possible to reach a certain date.

Parameters

  [in] | dates | the list of dates for which the coordinates are to be computed in proper time or affine parameter if #proper is true or in coordinate time if #proper is false (default);
  [in] | n_dates | the number of dates to compute ;
  [out] | x1dest,x2dest,x3dest,x0dot,x1dot,x2dot,x3dot | arrays in which to store the result. These pointer may be set to NULL to retrieve only part of the information. They must be pre-allocated.
  [out] | ephi0,ephi1,ephi2,ephi3,etheta0,etheta1,etheta2,etheta3 | arrays in which to store the ephi and etheta (parallel transport case). These pointer may be set to NULL to retrieve only part of the information. They must be pre-allocated.
  [out] | otime | array in which to store the other time: coordinate time if #proper, else proper time or affine parameter.
  [in] | proper | bool: whether #dates is proper time (or affine parameter) or coordinate time.

## getCoord() [3/5]

void Gyoto::Worldline::getCoord | ( | double | date,
|  | Gyoto::state_t & | dest,
|  | bool | proper = false )

Get coordinates+base vectors corresponding to date dest[0].

Depending on the value of parallel_transport_, get position (xi_), velocity (xidot_) and possibly other triad vectors (epi_ and eti_). coord is resized to the right number of elements.

## getCoord() [4/5]

void Gyoto::Worldline::getCoord | ( | size_t | index,
|  | Gyoto::state_t & | dest )

Get coordinates+base vectors corresponding to index.

We need this non-const implementation to allow the const, size_t and the non-const, double implementations to coexist.

## getCoord() [5/5]

void Gyoto::Worldline::getCoord | ( | size_t | index,
|  | Gyoto::state_t & | dest ) const

Get coordinates+base vectors corresponding to index.

Depending on the value of parallel_transport_, get position (xi_), velocity (xidot_) and possibly other triad vectors (epi_ and eti_). coord is resized to the right number of elements.

## getCst()

double const * Gyoto::Worldline::getCst | ( |  | ) | const

Returns the worldline's cst of motion (if any).

Return pointer to array holding the previously set Metric-specific constants of motion.

This function returns a pointer to the actual storage location and should be handled with care. std::vector<double> Worldline:constantsOfMotion() const provides a convenient way to retrieve a copy of the content.

## getInitialCoord()

void Gyoto::Worldline::getInitialCoord | ( | std::vector< double > & | dest | ) | const

Get initial coordinates + base vectors.

Depending on the size of dest and on the value of parallel_transport_, get position (xi_), velocity (xidot_) and possibly other triad vectors (epi_ and eti_).

## getMass()

virtual double Gyoto::Worldline::getMass | ( |  | ) | const

pure virtual

Get mass of particule.

Implemented in Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::Star, and Gyoto::Photon.

## integ31()

void Gyoto::Worldline::integ31 | ( | bool | integ | ) |

Set the integrator kind to 3+1 or 4D.

Initialize state_ to use the required geodesic equation.

## integrator()

void Gyoto::Worldline::integrator | ( | std::string const & | type | ) |

Set the integrator.

Initialize state_ to use the required integrator.

Parameters

  [in] | type | Either "Legacy" or (if GYOTO_HAVE_BOOST_INTEGRATORS) one of "runge_kutta_cash_karp54", "runge_kutta_fehlberg78", "runge_kutta_dopri5", "runge_kutta_cash_karp54_classic"

## setCst()

void Gyoto::Worldline::setCst | ( | double const * | cst,
|  | size_t const | ncsts )

Set Metric-specific constants of motion.

The will (re)allocate Worldline::cst_, copy cst into it, and set Worldline::cst_n_.

This is the same as void Worldline:constantsOfMotion(std::vector<double> const cstv) using a C-style array instead of a vector.

## setInitCoord() [1/3]

virtual void Gyoto::Worldline::setInitCoord | ( | const double | coord[8],
|  | int | dir,
|  | double const | Ephi[4],
|  | double const | Etheta[4] )

virtual

Set Initial coordinate.

Set imin_=imax_=i0_, and x[i0]=coord[].

If dir==1, i0_ is set to 0. If dir==-1, i0_ is set to x_size_-1.

If dir==0 and the Worldine has never been computed (i0_==0, imin_==1 and imax_==0), then dir defaults to 1 for a massive particle and -1 for a massless particle.

If dir==0 and the Worldine has already been computed, i0_ is not changed.

Parameters

  coord | new initial coordinates
  dir | direction of integration. 1 for forward integration, -1 for backards integration, 0 for unknown or both
  Ephi | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.
  Etheta | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.

## setInitCoord() [2/3]

virtual void Gyoto::Worldline::setInitCoord | ( | const double | coord[8],
|  | int | dir = 0 )

virtual

Set Initial coordinate.

Set imin_=imax_=i0_, and x[i0]=coord[].

If dir==1, i0_ is set to 0. If dir==-1, i0_ is set to x_size_-1.

If dir==0 and the Worldine has never been computed (i0_==0, imin_==1 and imax_==0), then dir defaults to 1 for a massive particle and -1 for a massless particle.

If dir==0 and the Worldine has already been computed, i0_ is not changed.

Parameters

  coord | new initial coordinates
  dir | direction of integration. 1 for forward integration, -1 for backards integration, 0 for unknown or both

Reimplemented in Gyoto::Astrobj::StarTrace.

## setInitCoord() [3/3]

virtual void Gyoto::Worldline::setInitCoord | ( | double const | pos[4],
|  | double const | vel[3],
|  | int | dir = 0 )

virtual

Set initial coordinate.

Parameters

  pos | initial 4-position
  vel | initial 3-velocity
  dir | direction of integration

## setInitialCondition() [1/2]

void Gyoto::Worldline::setInitialCondition | ( | SmartPointer< Metric::Generic > | gg,
|  | const double | coord[8],
|  | const int | dir )

Set or re-set the initial condition prior to integration.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this universe;
  coord | 8 element array containing the initial condition, i.e. the 4-position and the 4-velocity of the Photon at the receiving end;
  dir | direction: 1 for future, -1 for past.

## setInitialCondition() [2/2]

void Gyoto::Worldline::setInitialCondition | ( | SmartPointer< Metric::Generic > | gg,
|  | const double | coord[8],
|  | const int | dir,
|  | double const | Ephi[4],
|  | double const | Etheta[4] )

Set or re-set the initial condition prior to integration.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this universe;
  coord | 8 element array containing the initial condition, i.e. the 4-position and the 4-velocity of the Photon at the receiving end;
  dir | direction: 1 for future, -1 for past.
  Ephi | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.
  Etheta | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.

## tell()

virtual void Gyoto::Worldline::tell | ( | Gyoto::Hook::Teller * | msg | ) |

protected virtual

This is how a Teller tells.

A teller will basically call listener->tell(this).

Parameters

  msg | Teller* the Teller who is telling... Useful if the Listener listens to several Tellers.

Reimplemented from Gyoto::Hook::Listener.

## xAllocate() [1/2]

virtual void Gyoto::Worldline::xAllocate | ( |  | ) |

protected virtual

Allocate x0, x1 etc. with default size.

The default size is GYOTO_DEFAULT_X_SIZE

## xAllocate() [2/2]

virtual void Gyoto::Worldline::xAllocate | ( | size_t | size | ) |

protected virtual

Allocate x0, x1 etc. with a specified size.

Parameters

  size | : number of cells in each array x0, x1 etc.

Reimplemented in Gyoto::Astrobj::StarTrace.

## xExpand() [1/2]

virtual void Gyoto::Worldline::xExpand | ( | double *& | x,
|  | int | dir )

protected virtual

Expand one array to hold more elements.

If you need to expand more arrays than x0_ ... x3_ and the dots, call this on your array before calling xExpand(int dir).

Parameters

  [in,out] | x | array to expand
  [in] | dir |

## xExpand() [2/2]

virtual size_t Gyoto::Worldline::xExpand | ( | int | dir | ) |

protected virtual

Expand x0, x1 etc... to hold more elements.

Double the size of arrays x0, x1 etc. and copy old version of the array in the first half if dir =1 and in the second half if dir =-1.

Parameters

  dir | : 1 to expand after last element, -1 to expand before first element

Returns
  ind : if dir=1, new index of old last element, if dir=-1, new index of old first element

Reimplemented in Gyoto::Astrobj::StarTrace.

## xStore()

virtual void Gyoto::Worldline::xStore | ( | size_t | ind,
|  | state_t const & | coord,
|  | double | tau )

virtual

Store coord at index ind.

Reimplemented in Gyoto::Astrobj::StarTrace.

## Member Data Documentation

## abstol_

double Gyoto::Worldline::abstol_

protected

Absolute tolerance of the integrator.

Used by the adaptive integrators implemented in IntegState::Boost. Refer to the boost::numeric::odeint documentation for more details.

## delta_

double Gyoto::Worldline::delta_

protected

Initial integrating step.

Default: GYOTO_DEFAULT_DELTA

## delta_max_

double Gyoto::Worldline::delta_max_

protected

Maximum integration step for the adaptive integrator.

The default (GYOTO_DEFAULT_DELTA_MAX) is usually fine.

For IntegState::Legacy, set it in the Metric instead!

## delta_max_over_r_

double Gyoto::Worldline::delta_max_over_r_

protected

Numerical tuning parameter.

For IntegState::Legacy, set it in the Metric instead!

Ensure that delta (the numerical integration step) is never larger than a fraction of the distance between the current location and the center of the coordinate system.

The default (GYOTO_DEFAULT_DELTA_MAX_OVER_R) is usually fine.

## delta_min_

double Gyoto::Worldline::delta_min_

protected

Minimum integration step for the adaptive integrator.

The default (GYOTO_DEFAULT_DELTA_MIN) is usually fine.

For IntegState::Legacy, set it in the Metric instead!

## maxCrossEqplane_

double Gyoto::Worldline::maxCrossEqplane_

protected

Maximum number of crossings of equatorial plane.

Used to determine how much higher-order image features should be kept.

## parallel_transport_

bool Gyoto::Worldline::parallel_transport_

protected

Whether to parallel transport a local triad.

Typically used to trace the base in which the Stokes parameters are expressed in the context of polarization.

## reltol_

double Gyoto::Worldline::reltol_

protected

Absolute tolerance of the integrator.

Used by the adaptive integrators implemented in IntegState::Boost. Refer to the boost::numeric::odeint documentation for more details.

## secondary_

bool Gyoto::Worldline::secondary_

protected

Experimental: choose 0 to compute only primary image.

This feature is in development.

## tmin_

double Gyoto::Worldline::tmin_

protected

Time limit for the integration (geometrical units).

Computation does not go back before tmin_. Default is -DBL_MAX. tmin_ is always expressed in geometrical units, it is essentially a tuning parameter for the ray-tracing process. tmin_ should be chosen to always be longer than the distance between the screen and the object.

## x_size_

size_t Gyoto::Worldline::x_size_

protected

Coordinate of Second base vector to parallel transport.

Size of x0_, x1_... arrays

The documentation for this class was generated from the following file:

- GyotoWorldline.h